// Randomness
rand('uniform');
rand('seed', getdate('s'));
// Instances per class
n = 100
// Covariance
cov = [0.2 0; 0 2]
// Label noise
p = 0.15

// Klasse +1:
data_pos = grand(n,'mn',[1 1]', cov)';
nois_pos = grand(n,'mn',[0 0]', eye(2,2))';
noisy_data_pos = data_pos + nois_pos;
class_pos = ones(n,1);
noisy_class_pos = class_pos .* ((rand(class_pos) <= p) * (-2) + 1);

// Klasse -1:
data_neg = grand(n,'mn',[-1 -1]', cov)';
nois_neg = grand(n,'mn',[0 0]', eye(2,2))';
noisy_data_neg = data_neg + nois_neg;
class_neg = -ones(n,1);
noisy_class_neg = class_neg .* ((rand(class_neg) <= p) * (-2) + 1);


full_org = [[data_pos, class_pos]; [data_neg, class_neg]];
full_noisy_data = [[noisy_data_pos, class_pos]; [noisy_data_neg, class_neg]];
full_noisy_class = [[data_pos, noisy_class_pos]; [data_neg, noisy_class_neg]];
full_noisy = [[noisy_data_pos, noisy_class_pos]; [noisy_data_neg, noisy_class_neg]];

dc = cell(1,4);
dc(1).entries = full_org;
dc(2).entries = full_noisy_data;
dc(3).entries = full_noisy_class;
dc(4).entries = full_noisy;

names = ["org", "noisy_data", "noisy_class", "noisy"];

head = ["";
"@ATTRIBUTE x REAL";
"@ATTRIBUTE y REAL";
"@ATTRIBUTE class {-1,1}";
"";
"@DATA"];

//figure();
//plot(data_pos(:,1), data_pos(:,2),"o");
//plot(data_neg(:,1), data_neg(:,2),"rp");

//figure();
//plot(noisy_data_pos(:,1), data_pos(:,2),"o");
//plot(noisy_data_neg(:,1), data_neg(:,2),"rp");

for i = 1:max(size(dc))
    d = dc(i).entries;
    name = names(i);
    fprintfMat(name + ".arff", d, "%.15g", ["@RELATION crammer_" + name; head]);
    h = figure("BackgroundColor", [1 1 1]);
    for n = 1:max(size(d))
        r = d(n,:);
        if r(3) == 1 then
            plot(r(1), r(2), "o");
        else
            plot(r(1), r(2), "rp");
        end
    end
    xs2pdf(h, name);
    close(h);
end











